/**
 * DO NOT EDIT
 *
 * This file was automatically generated by
 *   https://github.com/Polymer/tools/tree/master/packages/gen-typescript-declarations
 *
 * To modify these typings, edit the source file(s):
 *   src/ApiHeadersFormItem.js
 */


// tslint:disable:variable-name Describing an API that's defined elsewhere.
// tslint:disable:no-any describes the API as best we are able today

import {html, LitElement} from 'lit-element';

import {ValidatableMixin} from '@anypoint-web-components/validatable-mixin/validatable-mixin.js';

export {ApiHeadersFormItem};

/**
 * Headers form item.
 *
 * Provides UI to enter headers data and autocomplete function for both header
 * names and values.
 */
declare class ApiHeadersFormItem extends
  ValidatableMixin(
  LitElement) {
  readonly styles: any;
  legacy: any;
  name: any;
  value: any;
  constructor();
  render(): any;

  /**
   * Toggles documentation (if available)
   */
  toggleDocs(): void;

  /**
   * Dispatches `name-changed` event.
   *
   * @param value A value to notify
   */
  _notifyNameChange(value: string): void;

  /**
   * Dispatches `value-changed` event.
   *
   * @param value A value to notify
   */
  _notifyValueChange(value: string): void;

  /**
   * Handler for header name field focus. It sets `_nameInput` property and
   * requests for header names suggestions to render the autocomplete.
   */
  _headerNameFocus(e: CustomEvent|null): void;

  /**
   * A handler called when the user selects a suggestion.
   */
  _onHeaderNameSelected(e: CustomEvent|null): void;

  /**
   * Handler for autocomplete element. Query the datastore for suggestions.
   *
   * @param e Autocomplete event
   */
  _headerNameHandler(e: CustomEvent|null): void;

  /**
   * Queries and sets suggestions for name.
   *
   * @param query The header name to query for.
   */
  _setNameSuggestions(query: String|null): void;

  /**
   * Dispatches `query-headers` custom event to retreive from the application
   * headers definition.
   *
   * `api-headers-form` element contains `arc-definitions` element that
   * listens for this event.
   *
   * @param q Header name to query for
   * @returns Headers definition or empty array
   */
  _queryHeaderNameSuggestions(q: String|null): any[]|null;
  _getValidity(): any;

  /**
   * Updates value suggestions for custom values.
   *
   * @param name Header name
   */
  _nameChanged(name: String|null): void;

  /**
   * Updates header value autocomplete if header definition contains
   * the `autocomplete` entry. It only sets the autocomplete value when
   * only one header has been found for current input.
   *
   * @param headers List of received headers from headers query
   */
  _updateValueAutocomplete(headers: Array<object|null>|null): void;

  /**
   * Updates header description if the header doesn't contain a description
   * already.
   */
  _updateHeaderDocs(info: object|null): void;

  /**
   * Tests whether autocomplete element should be rendered.
   *
   * @param input Target element for autocomplete
   * @param suggestions List of suggestions.
   * @returns True when has the input and some suggestions.
   */
  _renderAutocomplete(input: HTMLElement|null, suggestions: any[]|null): Boolean|null;

  /**
   * Handler for name field value change. Sets new name on this element.
   */
  _nameValueHandler(e: CustomEvent|null): void;

  /**
   * Handler for name autocomplete opened changed event.
   * It sets opened flag so the element won't request for value suggestions while
   * autocomplete is opened.
   */
  _nameSuggestOpenHandler(e: CustomEvent|null): void;

  /**
   * Handler for value change from the value input
   */
  _valueChangeHandler(e: CustomEvent|null): void;

  /**
   * Handler for value autocomplete selection event.
   * Validates the input as after the autocomplete updates the value programatically
   * it won't trigger validation.
   */
  _valueSelectedHandler(): void;

  /**
   * If it is custom header then it focuses on the name ionput.
   * Otherwise it focuses on API form item.
   */
  focus(): void;

  /**
   * Dispatches `send-analytics` for GA event.
   */
  _gaEvent(category: String|null, action: String|null): void;
  _customTemplate(): any;
  _modelTemplate(): any;
}
